      program carlomat
c----------------------------------------------------------------------c
c Autmatized calculation of the cross section of SM process
c
c                 f_1 f_2 -> f_3 f_4 ... f_next
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 9 February, 2006; modified 
c----------------------------------------------------------------------c

      use mytypes
      use extpart

      implicit none

      character(80) :: process

c Specify a process below. The maximum number of external particles 
c is 12. 
c     Standard Model particles include (notation adapted from MadGraph)
c     Quarks:   d u s c b t d~ u~ s~ c~ b~ t~
c     Leptons:  e- mu- ta- e+ mu+ ta+ ve vm vt ve~ vm~ vt~
c     Bosons:   g a z w+ w- h

      process='e+ e- -> b b~ mu+ vm d u~'

c Monte Carlo summing over polarizations: imcs=1 (yes)/else (no)?

      imcs=1

c Take into account pure EW contributions: iewk=1(yes)/else(no)?

      iewk=0

c Discard the Higgs boson contributions: ihgs=1(yes)/else(no)?

      ihgs=0

      call readpart(process)

      call genmat

      end

