      subroutine genmat
c----------------------------------------------------------------------c
c Generates the matrix element
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 14 February, 2006; modified 23 February, 2006; 8 October, 2007;
c                             6/7 January, 2008 (reduction of the No of
c                             open files, where matrix elements are 
c                             added);
c                             20 March, 2008 (existing data files with
c                             topologies need not generated again)
c                             20 May, 2008
c----------------------------------------------------------------------c

      use maxvals
      use mytypes
      use extpart
      use intpart
      use psnname

      implicit none

      integer :: nun,i,id,idr,ipl,nf,l,ntin,ntop,ncls,
     &           npl,blad,plj,pli,plo,plg,plf,plct,pln,ple,
     &           nuni,nunf,icont,icon0,iconx,icl,icl0,icdec,iccon,
     &           lc,icla,plord(next),sgn,icon1,icony

      character(80) :: cl,clx,ind,cdec,ccon,ind1,ind2,ind3,ind4,ind5,
     &                 indp
      character(160) :: cl2
      character(240) :: cl3
      character(80), allocatable :: cla(:),matnm(:)
      integer, allocatable :: iclx(:),iclu(:)

c Set initial values of the No of Feynman diagrams, reduced No of 
c the diagrams and No of intermediate particles

      id=0
      idr=0
      ipl=0

      open(unit=11,file='matrixel.f',status='replace',action='write')
      open(unit=12,status='scratch',action='readwrite')
      open(unit=14,status='scratch',action='readwrite',recl=160)
      open(unit=15,status='scratch',action='readwrite')
      open(unit=70,status='scratch',action='readwrite')
c      open(unit=111,file='reddgs.tmp',status='replace',
c     &                                            action='readwrite')
      open(unit=111,file='scratch',status='replace',
     &                                            action='readwrite')
      open(unit=26,file='colsqkk.f',status='replace',action='write')

      call begincolsq(26,ncol)

      call preamble(11)

      pl(:)%wr=0

      nf=0

c      open(13,file='colfs.txt',access='direct',form='formatted',
c     &                                                     recl=80)
      open(unit=13,status='scratch',access='direct',form='formatted',
     &                                   action='readwrite',recl=80)
c      open(18,file='calls.txt',access='direct',form='formatted',
c     &                                                     recl=160)
      open(18,status='scratch',access='direct',form='formatted',
     &                                                     recl=160)
c      open(20,file='orders.tmp',access='direct',form='formatted',
c     &                                                     recl=80)
      open(20,status='scratch',access='direct',form='formatted',
     &                                                     recl=80)
      open(21,file='decls.txt',access='direct',form='formatted',
     &                                                     recl=80)
      open(unit=28,file='kincls.f',status='replace',action='write')
      open(unit=29,file='psnkk.f',status='replace',action='write')

ckk>
c      write(28,'(a)') '      subroutine kincls(ikin,ecm,p,x,ndim,'//
c     &                                                     'dlips)'
      write(28,'(a)') '      subroutine kincls(ikin,imom,ecm,p,x,ndim,'
     &                                                  //'dlips)'
ckk<
      write(28,'(a)') ' '
      write(28,'(a)') '      use partcls'
      write(28,'(a)') ' '
      write(28,'(a)') '      implicit none'
      write(28,'(a)') ' '
ckk>
c      write(28,'(a)') '      integer, parameter :: dp=kind(1.d0),'//
c     &                       'imom=1'
c      write(28,'(a)') '      integer :: ikin,ndim'
c      write(28,'(a)') '      integer, parameter :: dp=kind(1.d0)'
      write(28,'(a)') '      integer :: ikin,imom,ndim'
ckk<
      write(indp,'(i16)') kind(1.d0)
      write(28,'(a)') '      real('//trim(adjustl(indp))//
     &                ') :: ecm,p(0:3,nepl),x(ndim),dlips'
      write(28,'(a)') ' '

      write(29,'(a)') '      subroutine psnkk(ikin0,ecm,p,x,ndim,dlinv)'
      write(29,'(a)') ' '
      write(29,'(a)') '      use partcls'
      write(29,'(a)') ' '
      write(29,'(a)') '      implicit none'
      write(29,'(a)') ' '
c      write(29,'(a)') '      integer, parameter :: dp=kind(1.d0),'//
c     &                       'imom=0'
c      write(29,'(a)') '      integer :: ikin0,ndim,ikin'
      write(29,'(a)') '      integer :: ikin0,ndim'
      write(29,'(a)') '      real('//trim(adjustl(indp))//
     &                ') :: ecm,p(0:3,nepl),x(ndim),dlinv,dlips0'
c     &                     'dlinv,dlips,dlips0'
      write(29,'(a)') ' '
      write(29,'(a)') '      dlips0=dlinv'
      write(29,'(a)') '      dlinv=0.d0'
      write(29,'(a)') ' '
c      write(29,'(a)') '      do ikin=1,nkin'
c      write(29,'(a)') '       if (aw(ikin) > 0.d0) then'

      do i=1,next
       ipl=ipl+1
       pl(ipl)%k=0
       iplord=ipl
c       pl(ipl)%k(0)=iplord
       write(20,'(26(i3))',rec=iplord) iplord
       allocate(pl(ipl)%ip(0),stat=blad)
       pl(ipl)%ct=f(ipl)%ct
       write(13,'(a)',rec=ipl) '1'
       if (f(ipl)%j < 21) then
        nf=nf+1
        write(ind,'(i16)') ipl
        write(ind1,'(i16)') f(ipl)%n
        cl='u'//trim(adjustl(ind))//'(4,'//trim(adjustl(ind1))//')'
        write(21,'(a)',rec=ipl) cl
        write(ind2,'(i16)') f(ipl)%i
        write(ind3,'(i16)') f(ipl)%o
        if (f(ipl)%mc == 0) then
         write(ind4,'(i16)') 0
         write(ind5,'(a)') '0.d0'
        else
         write(ind4,'(i16)') imcs
         write(ind5,'(i16)') f(ipl)%mc
         ind5='phi('//trim(adjustl(ind5))//')'
        end if
c        write(18,'(a)',rec=ipl) '      call spinorkk(p'//
c     &      trim(adjustl(ind))//','//
c     &      trim(f(ipl)%m)//','//trim(adjustl(ind2))//','//
c     &      trim(adjustl(ind3))//',u'//trim(adjustl(ind))//','//
c     &      trim(adjustl(ind1))//')'

        write(18,'(a)',rec=ipl) '      call spinorkk(p'//
     &      trim(adjustl(ind))//','//
     &      trim(f(ipl)%m)//','//trim(adjustl(ind2))//','//
     &      trim(adjustl(ind3))//','//trim(adjustl(ind4))//','
     &      //trim(adjustl(ind5))//',u'//trim(adjustl(ind))
     &      //','//trim(adjustl(ind1))//')'
        pl(ipl)%wr=1
       else
        if (f(ipl)%f > 0) then
         write(ind,'(i16)') ipl
         write(ind1,'(i16)') f(ipl)%n
         if (f(ipl)%mc == 0) then
          write(ind4,'(i16)') 0
          write(ind5,'(a)') '0.d0'
         else
          write(ind4,'(i16)') imcs
          write(ind5,'(i16)') f(ipl)%mc
          ind5='phi('//trim(adjustl(ind5))//')'
         end if

         write(18,'(a)',rec=ipl) '      call recpolkk(p'//
     &      trim(adjustl(ind))//','//
     &      trim(f(ipl)%m)//','//trim(adjustl(ind4))//','
     &      //trim(adjustl(ind5))//',u'//trim(adjustl(ind))//','//
     &      trim(adjustl(ind1))//')'
         cl='u'//trim(adjustl(ind))//'(0:3,'//trim(adjustl(ind1))//')'
         write(21,'(a)',rec=ipl) cl
        else
         write(18,'(a)',rec=ipl) ' '
         write(ind,'(i16)') ipl
         write(ind1,'(i16)') f(ipl)%n
         cl='u'//trim(adjustl(ind))//'(1,'//trim(adjustl(ind1))//')'
         write(21,'(a)',rec=ipl) cl
         write(18,'(a)',rec=ipl) '      u'//trim(adjustl(ind))//'=onec'
        end if
        pl(ipl)%wr=1   ! This must work also for the Higgs
       end if
      end do

c      close(18)
c      close(20)
c      close(13)

      nexpl=ipl

      ntin=0
      ncls=0

      nuni=1
      nunf=2

      npl=next

      write(ind1,'(i16)') npl-1
      open(unit=nuni,file='topol'//trim(adjustl(ind1))//'.dat',
     &                           status='old',action='read',err=200)
c      if (npl > 4) then 
c       open(unit=3,file='topnos.dat',access='direct',form='formatted',
c     &                             status='old',action='read',recl=80)
c       read(3,'(i16)',rec=npl-4) ntin
c       close(3)
c      end if
      if (npl == 5) then
       ntin=4
      else if (npl == 6) then
       ntin=25
      else if (npl == 7) then
       ntin=220
      else if (npl == 8) then
       ntin=2485
      else if (npl == 9) then
       ntin=34300
      else if (npl == 10) then
       ntin=559405
      else if (npl == 11) then
       ntin=10525900
      else if (npl == 12) then
       ntin=224449225
      end if
      call gentop(nuni,nunf,npl,ntin,ntop,ncls,id,idr,ipl)
      close(nuni)

      go to 300

 200  npl=4

      do 
       if (npl > 4) then
        write(ind1,'(i16)') npl-1
        open(unit=nuni,file='topol'//trim(adjustl(ind1))//'.dat',
     &                                  status='old',action='read')
        rewind nuni
       end if
       if (npl < next .or. npl == 4) then
        write(ind1,'(i16)') npl
        open(unit=nunf,file='topol'//trim(adjustl(ind1))//'.dat',
     &                            status='replace',action='write')
       end if

       call gentop(nuni,nunf,npl,ntin,ntop,ncls,id,idr,ipl)

       if (npl > 4) then
        close(nuni)
       end if
       if (npl < next .or. npl == 4) then
        close(nunf)
c        if (npl == 4) then
c         open(unit=3,file='topnos.dat',access='direct',form='formatted',
c     &                        status='replace',action='write',recl=80)
c        else
c         open(unit=3,file='topnos.dat',access='direct',form='formatted',
c     &                        status='old',action='write',recl=80)
c        end if
c        write(3,'(i16)',rec=npl-3) ntop
c        close(3)
       end if
       nun=nunf
       nunf=nuni
       nuni=nun
       ntin=ntop
       if (npl == next) exit
       npl=npl+1
      end do



 300  if (id == 0) then
       write(*,*)'No Feynman diagrams for this process'
       write(*,*)'Try another one!'
       stop
      end if


      open(unit=17,file='partcls.f',status='replace',action='write')
      call wrpartcls(17,next,nisp,nmcs,id,iewk,ihgs)
      close(17)


      open(16,file='partcls.tmp',access='direct',form='formatted',
     &                                                     recl=80)
      open(unit=19,file='partcls.dat',status='replace',action='write')

      write(*,'(a,i10,a,i10,a)') 'Of',ipl-next,' internal particles '//
     & 'created the following',ncls,' are used:'

      do i=next+1,ipl
       read(16,1612,rec=i) plj,pli,plo,plg,plf,plct,pln,ple
       if (i <= next) then
        if (plj > 20 .and. plj /= 24) then
c Restore old conventions for neutral bosons
         pli=1
        end if
c         write(19,1610) pli,plo,plg,plf,plct,pln,expc(i)
        if (pl(i)%wr > 0) then
         write(*,3) i,plo*pli*plj,pli,plo,pln,ple 
c        write(*,*) pl(i)%k
        end if
       else
        if (plj > 20) then
c Restore old conventions for intermediate bosons
         if (plj == 24) then
          if (plo == 1) then
           pli=-pli
          end if
          plo=0
         else
          pli=1
          plo=0
         end if
        end if
c         write(19,1614) pli,plo,plg,plf,plct,pln
        if (pl(i)%wr > 0) then
         write(6,3) i,plo*pli*plj,pli,plo,pln,ple 
c        write(*,*) pl(i)%k
        end if
       end if
      end do
 1612 format(6(i3),i24,i3)
 3    format('pl(',i10,'):',i4,i4,i4,i4,i4,9(i4))

 1610  format(i3,i3,i3,i3,i3,i24,a4)
 1614  format(i3,i3,i3,i3,i3,i24)


      write(19,'(a)') '      prvrsn='''//trim(adjustl(prvrsn))
     &                                                        //''''

      do i=1,next
       write(ind,'(i16)') i
       write(19,'(a)') '      expc('//trim(adjustl(ind))//
     &                              ')='//''''//trim(expc(i))//''''
       write(19,'(a)') '      expl('//trim(adjustl(ind))//
     &                              ')='//"'"//expl(i)//"'"
       write(19,'(a)') '      m('//trim(adjustl(ind))//
     &                                       ')='//trim(f(i)%m)
       write(19,'(a)') '      wdth('//trim(adjustl(ind))//
     &                                       ')='//trim(f(i)%w)
      end do



      close(16)
      close(19)

      write(*,*) ntop, ' topologies generated'
      write(*,*) id, ' Feynman diagrams generated'
      write(*,'(a,i10)') 'No of colored amplitudes reduced to', idr
      write(*,'(a)') '---------------------------------------------'//
     &  '--------------------'
      write(*,'(a)') 'Change to mc_computation in order to run the '//
     &  'Monte Carlo program.'
      write(*,'(a)') '---------------------------------------------'//
     &  '--------------------'

      rewind 70

      write(ind,'(i16)') idr
      write(ind1,'(i16)') nhel

      write(11,'(a)')'      integer, parameter :: rdgs='
     &               //trim(adjustl(ind))
      write(ind,'(i16)') nhip
      write(ind1,'(i16)') nidp
      write(ind2,'(i16)') ncip
      write(11,'(a)')'      integer, parameter :: nhip='
     &               //trim(adjustl(ind))//', nidp='
     &               //trim(adjustl(ind1))//', ncip='
     &               //trim(adjustl(ind2))
      write(11,'(a)')'      real('//trim(adjustl(indp))//
     &               ') :: comfac(rdgs,rdgs),mpol2'
c      write(11,'(a)')'      complex(dp) :: mat(rdgs)'

      write(11,*) ' '


      open(unit=9,file='hmodkk.f',status='replace',action='write')

      write(9,'(a)') '      module hmodkk'
      write(9,'(a)') ' '
      write(ind,'(i16)') nhel
      write(9,'(a)')'      integer, parameter :: nhel='
     &               //trim(adjustl(ind))
      write(9,'(a)') ' '


      icont=0
      icon0=0
      iconx=0
      clx=''
      cdec='      integer, dimension(nhel)::'
      ccon='     &'
      icdec=len_trim(cdec)
      iccon=len_trim(ccon)

      do i=1,ipl
       if (pl(i)%wr == 1) then
        if (iconx == icon0) then
         icl0=icdec
         icl=icdec+len_trim(clx)
         cl(1:icl)=trim(cdec)//trim(clx)
         icon0=icon0+1
        end if

        write(ind,'(i16)') i
c        write(ind,'(i16)') pl(i)%k(0)

        if (i == ipl) then
         clx='h'//trim(adjustl(ind))
        else
         clx='h'//trim(adjustl(ind))//','
        end if

        icl0=icl
        icl=icl+len_trim(clx)

        if (icl > 72) then
         icl=icl0
         if ((icont+1)/mxncnt == icon0) then
          write(9,'(a)') cl(1:icl-1)
          write(9,'(a)') ' '
         else
          write(9,'(a)') cl(1:icl)
         end if
         if (i == ipl) then
          icl=icdec+len_trim(clx)
          cl(1:icl)=trim(cdec)//trim(clx)
          write(9,'(a)') cl(1:icl)
         else
          icont=icont+1
c Changed on 20 May, 2008:------------------------>
c          icl0=iccon
c          icl=iccon+len_trim(clx)
c          cl(1:icl)=trim(ccon)//trim(clx)
          if (icont/mxncnt == icon0) then
           icl0=icdec
           icl=icdec+len_trim(clx)
           cl(1:icl)=trim(cdec)//trim(clx)
          else
           icl0=iccon
           icl=iccon+len_trim(clx)
           cl(1:icl)=trim(ccon)//trim(clx)
          end if
c--------------------------------------------------<
         end if
        else
         cl(icl0+1:icl)=clx
        end if
        iconx=icont/mxncnt
       end if

       if (i == ipl) then
        if (index(trim(cl(1:icl)),',',.true.) == icl) then
         write(9,'(a)') cl(1:icl-1)
        else
         write(9,'(a)') cl(1:icl)
        end if
       end if
      end do

      write(9,'(a)')' '
      write(9,'(a)') '      end module hmodkk'
      close(9)


      open(unit=8,file='pmodkk.f',status='replace',action='write')

      write(8,'(a)') '      module pmodkk'
      write(8,'(a)') ' '
c      write(8,'(a)') '      integer, parameter :: dp=kind(1.d0)'
c      write(8,'(a)') '      use mathprms'
c      write(8,'(a)') ' '

      icont=0
      icon0=0
      iconx=0
      clx=''
      cdec='      real('//trim(adjustl(indp))//'), dimension(0:3)::'
      ccon='     &'
      icdec=len_trim(cdec)
      iccon=len_trim(ccon)

      do i=1,ipl
       if (pl(i)%wr == 1) then
        if (iconx == icon0) then
         icl0=icdec
         icl=icdec+len_trim(clx)
         cl(1:icl)=trim(cdec)//trim(clx)
         icon0=icon0+1
        end if

        write(ind,'(i16)') i

        if (i == ipl) then
         clx='p'//trim(adjustl(ind))
        else
         clx='p'//trim(adjustl(ind))//','
        end if

        icl0=icl
        icl=icl+len_trim(clx)

        if (icl > 72) then
         icl=icl0
         if ((icont+1)/mxncnt == icon0) then
          write(8,'(a)') cl(1:icl-1)
          write(8,'(a)') ' '
         else
          write(8,'(a)') cl(1:icl)
         end if
         if (i == ipl) then
          icl=icdec+len_trim(clx)
          cl(1:icl)=trim(cdec)//trim(clx)
          write(8,'(a)') cl(1:icl)
         else
          icont=icont+1
c Changed on 20 May, 2008:------------------------>
c          icl0=iccon
c          icl=iccon+len_trim(clx)
c          cl(1:icl)=trim(ccon)//trim(clx)
          if (icont/mxncnt == icon0) then
           icl0=icdec
           icl=icdec+len_trim(clx)
           cl(1:icl)=trim(cdec)//trim(clx)
          else
           icl0=iccon
           icl=iccon+len_trim(clx)
           cl(1:icl)=trim(ccon)//trim(clx)
          end if
c--------------------------------------------------<
         end if
        else
         cl(icl0+1:icl)=clx
        end if
        iconx=icont/mxncnt
       end if
       if (i == ipl) then
        if (index(trim(cl(1:icl)),',',.true.) == icl) then
         write(8,'(a)') cl(1:icl-1)
        else
         write(8,'(a)') cl(1:icl)
        end if
       end if
      end do

      write(8,'(a)') ' '
      write(8,'(a)') '      end module pmodkk'

      close(8)

      open(unit=7,file='umodkk.f',status='replace',action='write')

      write(7,'(a)') '      module umodkk'
      write(7,'(a)') ' '
c      write(7,'(a)') '      use mathprms'
c      write(7,'(a)') ' '

      icont=0
      icon0=0
      iconx=0
      clx=''
      cdec='      complex('//trim(adjustl(indp))//')::'
      ccon='     &'
      icdec=len_trim(cdec)
      iccon=len_trim(ccon)

      do i=1,ipl
       if (pl(i)%wr == 1) then
        if (iconx == icon0) then
         icl0=icdec
         icl=icdec+len_trim(clx)
         cl(1:icl)=trim(cdec)//trim(clx)
         icon0=icon0+1
        end if

        write(ind,'(i16)') i

        read(21,'(a)',rec=i) clx
        clx=trim(clx)//','

        icl0=icl
        icl=icl+len_trim(clx)

        if (icl > 72) then
         icl=icl0
         if ((icont+1)/mxncnt == icon0) then
          write(7,'(a)') cl(1:icl-1)
          write(7,'(a)') ' '
         else
          write(7,'(a)') cl(1:icl)
         end if
         if (i == ipl) then
          icl=icdec+len_trim(clx)
          cl(1:icl)=trim(cdec)//trim(clx)
          write(7,'(a)') cl(1:icl)
         else
          icont=icont+1
c Changed on 20 May, 2008:------------------------>
c          icl0=iccon
c          icl=iccon+len_trim(clx)
c          cl(1:icl)=trim(ccon)//trim(clx)
          if (icont/mxncnt == icon0) then
           icl0=icdec
           icl=icdec+len_trim(clx)
           cl(1:icl)=trim(cdec)//trim(clx)
          else
           icl0=iccon
           icl=iccon+len_trim(clx)
           cl(1:icl)=trim(ccon)//trim(clx)
          end if
c--------------------------------------------------<
         end if
        else
         cl(icl0+1:icl)=clx
        end if
        iconx=icont/mxncnt
       end if
       if (i == ipl) then
        if (index(trim(cl(1:icl)),',',.true.) == icl) then
         write(7,'(a)') cl(1:icl-1)
        else
         write(7,'(a)') cl(1:icl)
        end if
       end if
      end do

      write(7,'(a)') ' '
      write(7,'(a)') '      end module umodkk'

      close(7)
      close(21)

c      open(unit=10,file='mmodkk.f',status='replace',action='write')

c      write(10,'(a)') '      module mmodkk'
c      write(10,'(a)') ' '
c      write(10,'(a)') '      use mathprms'
c      write(10,'(a)') ' '

      icon1=0
      icony=0
c      clx=''
      cdec='      complex('//trim(adjustl(indp))//')::'
      ccon='     &'
      icdec=len_trim(cdec)
      iccon=len_trim(ccon)

      do i=1,id
       if (icony == icon1) then
        icont=0
        icon0=0
        iconx=0
        clx=''
        icon1=icon1+1
        write(ind1,'(i16)') icon1
        open(unit=10,file='mmodkk'//trim(adjustl(ind1))//'.f',
     &                            status='replace',action='write')
        write(10,'(a)') '      module mmodkk'//trim(adjustl(ind1))
        write(10,'(a)') ' '
c        write(10,'(a)') '      integer, parameter :: dp=kind(1.d0)'
       end if

       if (iconx == icon0) then
        icl0=icdec
        icl=icdec+len_trim(clx)
        cl(1:icl)=trim(cdec)//trim(clx)
        icon0=icon0+1
       end if
       write(ind,'(i16)') i
       if (i == id) then
        clx='m'//trim(adjustl(ind))
       else
        clx='m'//trim(adjustl(ind))//','
       end if
       icl0=icl
       icl=icl+len_trim(clx)
       if (icl > 72) then
        icl=icl0
        if ((icont+1)/mxncnt == icon0) then
         write(10,'(a)') cl(1:icl-1)
         write(10,'(a)') ' '
        else
         write(10,'(a)') cl(1:icl)
        end if
        if (i == id) then
c         if (icont == icon0) then            ! Modified on
         if ((icont+1)/mxncnt == icon0) then  ! 8 Oct., 2007
          icl=icdec+len_trim(clx)
          cl(1:icl)=trim(cdec)//trim(clx)
          write(10,'(a)') cl(1:icl)
         else
          icl=iccon+len_trim(clx)
          cl(1:icl)=trim(ccon)//trim(clx)
          write(10,'(a)') cl(1:icl)
         end if
c Modified on 8 Oct., 2007:
         write(10,'(a)') ' '
         write(10,'(a)') '      end module mmodkk'//trim(adjustl(ind1))
         close(10)
         exit
c End of modification
        else
         icont=icont+1
c Changed on 20 May, 2008:------------------------>
c         icl0=iccon
c         icl=iccon+len_trim(clx)
c         cl(1:icl)=trim(ccon)//trim(clx)
         if (icont/mxncnt == icon0) then
          icl0=icdec
          icl=icdec+len_trim(clx)
          cl(1:icl)=trim(cdec)//trim(clx)
         else
          icl0=iccon
          icl=iccon+len_trim(clx)
          cl(1:icl)=trim(ccon)//trim(clx)
         end if
c--------------------------------------------------<
        end if
       else
        cl(icl0+1:icl)=clx
       end if
       iconx=icont/mxncnt

       icony=i/mxcmdl

       if (icony == icon1 .or. i == id) then
        if (cl(icl:icl) == ',') then
         write(10,'(a)') cl(1:icl-1)
        else
         write(10,'(a)') cl(1:icl)
        end if
        write(10,'(a)') ' '
        write(10,'(a)') '      end module mmodkk'//trim(adjustl(ind1))
        close(10)
       end if
      end do

c      write(10,'(a)') ' '
c      write(10,'(a)') '      end module mmodkk'
c      close(10)

      write(11,*) ' '

      write(11,1050)
 1050 format('      save first,comif,comfac')

      write(11,*)' '

c      open(18,file='calls.txt',access='direct',form='formatted',
c     &                                                     recl=160)

      do i=1,next
       write(ind,'(i12)') i
       cl='      p'//trim(adjustl(ind))//'=p(:,'//trim(adjustl(ind))//
     &                                                         ')'
       write(11,'(a)') trim(cl)
      end do

      write(11,*) ' '

      do i=1,next
       read(18,'(a)',rec=i) cl2
       write(11,'(a)') trim(cl2)
      end do

      write(11,*) ' '

      close(18,status='delete')


      rewind 14

      icon0=0
      iconx=0

      do i=1,ncls
       if (iconx == icon0) then
        icon0=icon0+1
        write(ind,'(i16)') icon0
        open(unit=4,file='mtel'//trim(adjustl(ind))//'.f',
     &                            status='replace',action='write')
        write(4,'(a)') '      subroutine mtel'//trim(adjustl(ind))
        write(4,'(a)') ' '
        write(4,'(a)') '      use inprms'
        write(4,'(a)') '      use couplsmkk'
        write(4,'(a)') '      use pmodkk'
        write(4,'(a)') '      use umodkk'
        write(4,'(a)') ' '
        write(4,'(a)') '      implicit none'
        write(4,'(a)') ' '
        write(11,'(a)') '      call mtel'//trim(adjustl(ind))
       end if

       read(14,'(a)') cl2
c       write(11,'(a)') trim(cl2)
c       call wrt72(11,cl2)
       call wrt72(4,cl2)

       iconx=i/mxcmdl

       if (iconx == icon0 .or. i == ncls) then
        write(4,'(a)') ' '
        write(4,'(a)') '      end subroutine mtel'//trim(adjustl(ind))
        close(4)
       end if
      end do

      close(14,status='delete')

      call endcolsq(26)
      close(26)

      close(70,status='delete')

      write(11,*) ' '

      write(11,'(a)') '      if (first == 1) then'
c      write(11,'($a)') '       nexh=(/'
      write(11,'(a$)') '       nexh=(/'

      do i=1,next-1
       write(ind,'(i1)') f(i)%n
c       write(11,'($a)') trim(adjustl(ind))//','
       write(11,'(a$)') trim(adjustl(ind))//','
      end do

      write(ind,'(i1)') f(next)%n
      write(11,'(a)') trim(adjustl(ind))//'/)'

c      open(20,file='orders.tmp',access='direct',form='formatted',
c     &                                                     recl=80)


      open(unit=5,file='hsubkk.f',status='replace',action='write')

      write(5,'(a)') '      subroutine hsubkk(next,nexh)'
      write(5,'(a)') ' '
      write(5,'(a)') '      use hmodkk'
      write(5,'(a)') ' '
      write(5,'(a)') '      implicit none'
      write(5,'(a)') ' '
      write(5,'(a)') '      integer :: next,nexh(next)'
      write(5,'(a)') ' '



      do i=1,ipl
       if (pl(i)%wr == 1) then
        read(20,'(26(i3))',rec=i) plord
        call wrordrs(5,plord,i)
       end if 
      end do

      write(5,'(a)') ' '
      write(5,'(a)') '      end subroutine hsubkk'

      close(5)
c      close(20)
      close(20,status='delete')
c      close(115)
      close(15,status='delete')

      write(11,'(a)') '       call hsubkk(next,nexh)'
      write(11,'(a)') '       comif=1.d0/(nhip*nidp*ncip)'
      write(11,'(a)') '       call colsqkk(comfac,rdgs)'
      write(11,'(a)') '       first=0'
      write(11,'(a)') '      end if'


      write(11,*)' '
      write(11,'(a)') '      mat2=0.d0'
      write(11,*)' '
      write(11,'(a)') '      do hl=1,nhel'
      write(11,'(a)') '       mat2=mat2+mpol2(hl,comfac)'
      write(11,'(a)') '      end do'
      write(11,*)' '
      write(11,'(a)') '      mat2=comif*mat2'
      write(11,*)' '
c      write(11,'(a)') '      contains'
      write(11,'(a)') '      end subroutine matrixel'
      close(11)

      open(unit=11,file='mpol2.f',status='replace',action='write')

      write(11,*)' '
      write(11,'(a)') '      function mpol2(h,comfac)'
      write(11,*)' '
c      write(11,'(a)') '      use mmodkk'
      do i=1,icon1
       write(ind,'(i16)') i
       write(11,'(a)') '      use mmodkk'//trim(adjustl(ind))
      end do
      write(11,*)' '
      write(11,'(a)') '      implicit none'
      write(11,*)' '
      write(ind,'(i16)') idr
      write(11,'(a)')'      integer, parameter :: rdgs='
     &               //trim(adjustl(ind))
      write(11,'(a)') '      integer :: h,i,j'
      write(11,'(a)') '      real('//trim(adjustl(indp))//
     &                ') :: mpol2,comfac(rdgs,rdgs)'
      write(11,'(a)') '      complex('//trim(adjustl(indp))//
     &                ') :: mtmp,mat(rdgs)'
      write(11,*)' '

      rewind 12

      ccon='     &'

c      open(unit=4,file='mdkk.f',status='replace',action='write')

      icon0=0
      iconx=0

      do i=1,id
       if (iconx == icon0) then
        icon0=icon0+1
        write(ind,'(i16)') icon0
        open(unit=4,file='mdkk'//trim(adjustl(ind))//'.f',
     &                            status='replace',action='write')
        write(4,'(a)') '      subroutine mdkk'//trim(adjustl(ind))
     &                                                     //'(h)'
        write(4,'(a)') ' '
        write(4,'(a)') '      use couplsmkk'
        write(4,'(a)') '      use hmodkk'
        write(4,'(a)') '      use mmodkk'//trim(adjustl(ind))
c        write(4,'(a)') '      use mmodkk'
        write(4,'(a)') '      use pmodkk'
        write(4,'(a)') '      use umodkk'
        write(4,'(a)') ' '
        write(4,'(a)') '      implicit none'
        write(4,'(a)') ' '
        write(4,'(a)') '      integer :: h'
        write(4,'(a)') ' '
        write(11,'(a)') '      call mdkk'//trim(adjustl(ind))//'(h)'
       end if

       read(12,'(a)') cl3
       call wrt72(4,cl3)

       iconx=i/mxcmdl

       if (iconx == icon0 .or. i == id) then
        write(4,'(a)') ' '
        write(4,'(a)') '      end subroutine mdkk'//trim(adjustl(ind))
        close(4)
       end if
      end do

c      close(4)
      close(12,status='delete')


c Sum matrix elements with the same particle orders and colour factors

      write(11,*)' '

      rewind 111

      allocate (cla(idr),stat=blad)
      allocate (matnm(idr),stat=blad)
      allocate (iclx(idr),stat=blad)
      allocate (iclu(idr),stat=blad)

      do i=1,idr
       write(ind,'(i16)') i
       matnm(i)='mtdr'//trim(adjustl(ind))//'.f'
       open(unit=30,file=trim(matnm(i)),status='replace',action='write')
       write(30,3010) trim(adjustl(ind))
 3010  format('      mat(',a,')=')
       close(30)
       cla(i)=ccon
       iclu(i)=0
      end do

      do i=1,id
       read(111,'(3(i16))') sgn,l,lc
       write(ind1,'(i16)') l
       if (sgn > 0) then
        clx=trim(cla(lc))//'+m'//trim(adjustl(ind1))
       else
        clx=trim(cla(lc))//'-m'//trim(adjustl(ind1))
       end if
       iclx(lc)=len_trim(clx)
       if (iclx(lc) > 72) then
        icla=len_trim(cla(lc))
        open(unit=30,file=trim(matnm(lc)),status='old',
     &                    position='append',action='write')
        if (iclu(lc)/19 == 1) then
         write(ind,'(i16)') lc
         write(30,3020) trim(adjustl(ind)),trim(adjustl(ind))
 3020    format('      mat(',a,')=mat(',a,')')
         iclu(lc)=iclu(lc)-19
        end if
        write(30,'(a)') cla(lc)(1:icla)
        close(30)
        iclu(lc)=iclu(lc)+1
        if (sgn > 0) then
         cla(lc)='     &+m'//trim(adjustl(ind1))
        else
         cla(lc)='     &-m'//trim(adjustl(ind1))
        end if
       else
        cla(lc)=clx
       end if
       iclx(lc)=len_trim(cla(lc))
      end do

      do i=1,idr
       open(unit=30,file=trim(matnm(i)),status='old',
     &                    position='append',action='write')
       if (iclu(i)/19 == 1) then
        write(ind,'(i16)') i
        write(30,3020) trim(adjustl(ind)),trim(adjustl(ind))
        iclu(i)=iclu(i)-19
       end if
       write(30,'(a)') cla(i)(1:iclx(i))
       close(30)
       iclu(i)=iclu(i)+1
      end do

      deallocate (cla,iclx,stat=blad)

      do i=1,idr
       write(11,3015) trim(matnm(i))
 3015  format('      include ''',a,'''')
      end do

      deallocate (iclu,matnm,stat=blad)

      write(11,*)' '
      write(11,'(a)') '      mpol2=0.d0'
      write(11,*)' '
      write(11,'(a)') '      do i=1,rdgs'
      write(11,'(a)') '       mtmp=(0.d0,0.d0)'
      write(11,'(a)') '       do j=i,rdgs'
      write(11,'(a)') '        if (j == i) then'
      write(11,'(a)') '         mtmp=mtmp+comfac(i,j)*mat(j)'
      write(11,'(a)') '        else'
      write(11,'(a)') '         mtmp=mtmp+2.d0*comfac(i,j)*mat(j)'
      write(11,'(a)') '        end if'
      write(11,'(a)') '       end do'
      write(11,'(a)') '       mpol2=mpol2+conjg(mat(i))*mtmp'
      write(11,'(a)') '      end do'
      write(11,*) ' '
      write(11,'(a)') '      end function mpol2'
c      write(11,*) ' '
c      write(11,'(a)') '      end'

      close(111,status='delete')
c      close(111)
      close(11)
c      close(13)
      close(13,status='delete')

      write(27,'(a)') '      end if'

c      write(27,'(a)') ' '
c      write(27,'(a)') '      if (imom == 1) then'
c      do i=nisp+1,nexpl
c       write(ind1,'(i16)') i
c       write(27,'(a)') '       p(:,'//trim(adjustl(ind1))//')=p'//
c     &                                   trim(adjustl(ind1))
c      end do
c      write(27,'(a)') '      end if'
      write(27,'(a)') ' '
      write(27,'(a)') '      end'

      close(27)

      write(28,'(a)') '      end if'
      write(28,'(a)') ' '
      write(28,'(a)') '      end'

      close(28)

c      write(29,'(a)') '        end if'
c      write(29,'(a)') '        if (dlips > 0.d0) then'
c      write(29,'(a)') '         dlinv=dlinv+aw(ikin)/dlips'
c      write(29,'(a)') '         if (ikin == ikin0) then'
c      write(29,'(a)') '          if (abs(dlips-dlips0)/dlips > 1.d-3)'//
c     &                                                         ' then'
c      write(29,'(a)') '           write(*,*)''Wrong p.s. normalization'
c     &                        //' for ikin='',ikin'
c      write(29,'(a)') '           write(*,*)''dlips:'',dlips0,dlips'
c      write(29,'(a)') '          end if'
c      write(29,'(a)') '         end if'
c      write(29,'(a)') '        end if'
c      write(29,'(a)') '       end if'
c      write(29,'(a)') '      end do'

      open(unit=4,file=trim(psnnm)//'.f',
     &           status='old',position='append',action='write')
      write(4,'(a)') ' '
      write(4,'(a)') '      end subroutine '//trim(psnnm)
      close(4)

      write(29,'(a)') ' '
      write(29,'(a)') '      end'

      close(29)


      contains

       subroutine wrordrs(iu,plorx,ix)
        integer :: iu,plorx(next),ix,ii,jj,iio,jjo,iorx,plox(nexpl)

        iorx=0

        do iio=ix-1,1,-1
         if (pl(iio)%wr == 1) then
          plox=0
          read(20,'(26(i3))',rec=iio) plox
          do jjo=1,next
           if (plox(jjo) == plorx(jjo) .and. plorx(jjo) /= 0) then
            if (jjo == next .or. 
     &          (plox(jjo+1) == 0 .and. plorx(jjo+1) == 0)) then
             iorx=iio
            end if
           else
            exit
           end if
          end do
          if (iorx > 0) then
           write(ind1,'(i16)') ix
           write(ind2,'(i16)') iorx
           write(iu,'(a)') '      h'//trim(adjustl(ind1))//'=h'//
     &                                trim(adjustl(ind2))
           exit
          end if
         end if
        end do

        if (iorx == 0) then

        jj=0
        do ii=1,next
         if (plorx(ii) == 0) then
          exit
         else
          jj=jj+1
         end if
        end do
c        write(iu,'($a)') '      call ix'
        write(iu,'(a$)') '      call ix'
        write(ind,'(i16)') jj
c        write(iu,'($a)') trim(adjustl(ind))//'(next,nexh,nhel,(/'
        write(iu,'(a$)') trim(adjustl(ind))//'(next,nexh,nhel,(/'

        do ii=1,jj-1
         if (plorx(ii) < 10) then
          write(iu,10) plorx(ii)
         else
          write(iu,20) plorx(ii)
         end if
        end do
        if (plorx(jj) < 10) then
c         write(iu,'($i1)') plord(jj)
         write(iu,'(i1$)') plord(jj)
        else
c         write(iu,'($i2)') plord(jj)
         write(iu,'(i2$)') plord(jj)
        end if
        write(ind,'(i16)') ix
        write(iu,'(a)') '/),h'//trim(adjustl(ind))//')'

        end if ! iorx

c 10     format($,i1,',')
c 20     format($,i2,',')
 10     format(i1,',',$)
 20     format(i2,',',$)

       end subroutine wrordrs

      end
