      subroutine colsqkk(cfd2,rdgs)
c=============================================================================c
c Calculates colour factors
c=============================================================================c
 
      integer :: rdgs
      integer, parameter :: ncls=3
      integer, parameter :: dp=kind(1.d0), nc2=ncls**2-1
      complex(dp), parameter :: ocom=(0.d0,0.d0),
     &                          onec=(1.d0,0.d0),
     &                          icom=(0.d0,1.d0)
      complex(dp) :: cfd(rdgs), t(nc2,ncls,ncls),
     &                          f(nc2,nc2,nc2)
      real(dp) :: d(ncls,ncls)
      real(dp), dimension(rdgs,rdgs) :: cfd2
 
c SU(3) group generators and structure constants:
 
      t(1,1,:)=(/ ocom, onec, ocom/)
      t(1,2,:)=(/ onec, ocom, ocom/)
      t(1,3,:)=(/ ocom, ocom, ocom/)
 
      t(2,1,:)=(/ ocom,-icom, ocom/)
      t(2,2,:)=(/ icom, ocom, ocom/)
      t(2,3,:)=(/ ocom, ocom, ocom/)
 
      t(3,1,:)=(/ onec, ocom, ocom/)
      t(3,2,:)=(/ ocom,-onec, ocom/)
      t(3,3,:)=(/ ocom, ocom, ocom/)
 
      t(4,1,:)=(/ ocom, ocom, onec/)
      t(4,2,:)=(/ ocom, ocom, ocom/)
      t(4,3,:)=(/ onec, ocom, ocom/)
 
      t(5,1,:)=(/ ocom, ocom,-icom/)
      t(5,2,:)=(/ ocom, ocom, ocom/)
      t(5,3,:)=(/ icom, ocom, ocom/)
 
      t(6,1,:)=(/ ocom, ocom, ocom/)
      t(6,2,:)=(/ ocom, ocom, onec/)
      t(6,3,:)=(/ ocom, onec, ocom/)
 
      t(7,1,:)=(/ ocom, ocom, ocom/)
      t(7,2,:)=(/ ocom, ocom,-icom/)
      t(7,3,:)=(/ ocom, icom, ocom/)
 
      t(8,1,:)=(/ onec, ocom, ocom/)/sqrt(3.d0)
      t(8,2,:)=(/ ocom, onec, ocom/)/sqrt(3.d0)
      t(8,3,:)=(/ ocom, ocom,-2.d0*onec/)/sqrt(3.d0)
 
      t=t/2.d0
 
      f=0.d0
 
      f(1,2,3)=1.d0
      f(1,4,7)=0.5d0
      f(2,4,6)=0.5d0
      f(2,5,7)=0.5d0
      f(3,4,5)=0.5d0
      f(1,5,6)=-0.5d0
      f(3,6,7)=-0.5d0
      f(4,5,8)=sqrt(3.d0)/2.d0
      f(6,7,8)=sqrt(3.d0)/2.d0
 
      do i1=1,nc2
       do i2=i1,nc2
        do i3=i2,nc2
         if (f(i1,i2,i3) /= 0.d0) then
          f(i1,i3,i2)=-f(i1,i2,i3)
          f(i2,i1,i3)=-f(i1,i2,i3)
          f(i2,i3,i1)=f(i1,i2,i3)
          f(i3,i1,i2)=f(i1,i2,i3)
          f(i3,i2,i1)=-f(i1,i2,i3)
         end if
        end do
       end do
      end do
 
      f=icom*f
 
 
      d=0.d0
      cfd2=0.d0
 
      do j=1,ncls
       d(j,j)=1.d0
      end do
 
      do i3=1,3
      do i4=1,3
      do i7=1,3
      do i8=1,3
 
      cfd=ocom
 
      cfd(1)=cfd(1)+
     &d(i7,i8)*d(i3,i4)
      cfd(2)=cfd(2)+
     &tt(i3,i4,i7,i8)

      do j=1,rdgs
      do k=j,rdgs
       cfd2(j,k)=cfd2(j,k)+conjg(cfd(j))*cfd(k)
      end do
      end do

      end do
      end do
      end do
      end do


      contains

      function tt(i,j,k,l)

      real(dp) :: tt
      integer :: i,j,k,l

      tt=-d(i,j)*d(k,l)/dble(2*ncls)+d(i,l)*d(k,j)/2.d0

      end function tt

      function c(r,i,j,k,l)

      real(dp) :: c
      integer :: r,i,j,k,l,m

      c=0.d0
      do m=1,nc2
       if (r == 1) then
        c=c-f(i,j,m)*f(m,k,l)
       else if (r == 2) then
        c=c-f(i,k,m)*f(m,l,j)
       else if (r == 3) then
        c=c-f(i,l,m)*f(m,j,k)
       else
        write(*,*)'colsqkk.f: Wrong colour coeff.',r
       end if
      end do
      end function c

      end subroutine colsqkk
