      subroutine parfixkk
c----------------------------------------------------------------------c
c Returns some SM paprameters
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 21 March, 2006; modified on
c----------------------------------------------------------------------c

      use mathprms 
      use inprms
      use drivekk
      use couplsmkk
      use partcls

      implicit none

      integer :: i

      real(dp) :: rwt,gwt,gamw0,gamhff,gamhbb,
     &            gamhwff,ewh,gamhzff,ezh,betath,gamhsm0,lamsq

c      real(dp) :: mf(3,4),gamf(3,4),mv(0:4),gamv(0:4)

      complex(dp) :: cmw,cmh,mh2,ma2,mw2,mz2
ckk>
      real(dp) :: gamwsm0,gamtsm0,gamtsm,gamt3
ckk<
c Coupling constants:

      e0=sqrt(4.d0*pi/ialph0)
      ew=sqrt(4.d0*pi/ialphw)
      es=sqrt(4.d0*pi*alphas)

c W boson width to lowest order of SM:

      gamwsm0=zero
      call wwidth(zero,me,mw,one,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0
      call wwidth(zero,mmu,mw,one,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0
      call wwidth(zero,mtau,mw,one,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0
      call wwidth(mu,md,mw,ncol,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0
      call wwidth(mc,ms,mw,ncol,one,ew,sw2,gamw0)
      gamwsm0=gamwsm0+gamw0

      if (gamw == 0.d0) then
       gamw=gamwsm0
      end if

cc The SM Higgs width:

c H -> ff~:

      gamhff=sqrt(2.d0)*gmu/(8.d0*pi)*mh
     &      *(me**2*(sqrt(1.d0-4.d0*(me/mh)**2))**3
     &       +mmu**2*(sqrt(1.d0-4.d0*(mmu/mh)**2))**3
     &       +mtau**2*(sqrt(1.d0-4.d0*(mtau/mh)**2))**3
     & +ncol*(mu**2*(sqrt(1.d0-4.d0*(mu/mh)**2))**3
     &       +md**2*(sqrt(1.d0-4.d0*(md/mh)**2))**3
     &       +mc**2*(sqrt(1.d0-4.d0*(mc/mh)**2))**3
     &       +ms**2*(sqrt(1.d0-4.d0*(ms/mh)**2))**3
     &       +mb**2*(sqrt(1.d0-4.d0*(mb/mh)**2))**3))

      gamhbb=sqrt(2.d0)*gmu/(8.d0*pi)*mh
     &       *ncol*mb**2*(sqrt(1.d0-4.d0*(mb/mh)**2))**3

      if (mh > 2.d0*mt) then
       betath=1.d0-4.d0*(mt/mh)**2
       gamhff=gamhff+sqrt(2.d0)*gmu/(8.d0*pi)*mh
     &       *ncol*mt**2*(sqrt(betath))**3
      end if


c H -> Wff'~

      ewh=mw/mh

      gamhwff=3.d0*(4.d0*sqrt(2.d0)*gmu*mw**2)**2/(512.d0*pi**3)*mh
     &       *f(ewh)

      ezh=mz/mh

      gamhzff=(4.d0*sqrt(2.d0)*gmu*mw**2)**2/(2048.d0*pi**3*(mw/mz)**4)
     &       *mh*(7.d0-40.d0/3.d0*sw2+160.d0/9.d0*sw2**2)*f(ezh)

      gamhsm0=gamhff+gamhwff+gamhzff

      if (gamh == 0.d0) then
       gamh=gamhsm0
      end if

c Complex masses squared:

      mw2=cmplx(mw**2,-mw*gamw,dp)
      ma2=cmplx(zero,zero,dp)
      mz2=cmplx(mz**2,-mz*gamz,dp)

      if (ischeme == 1) then
       csw2=(mz2-mw2)/mz2
       cmw=sqrt(mw2)
      else
       csw2=cmplx(sw2,0.d0,dp)
       cmw=cmplx(mw,0.d0,dp)
      end if


c The SM top width:

c---- total:

      gamtsm0=gmu*mt**3/(8.d0*pi*sqrt(2.d0))
     &       *(1.d0-(mw/mt)**2)**2*(1.d0+2.d0*(mw/mt)**2)

      gamtsm=gmu*mt**3/(8.d0*pi*sqrt(2.d0))
     &      *(1.d0-(mw/mt)**2)**2*(1.d0+2.d0*(mw/mt)**2)
     &      *(1.d0-2.d0*alphas/(3.d0*pi)*(2.d0*pi**2/3.d0-5.d0/2.d0))

c Including a nonzero bottom quark mass:

      gamtsm0=sqrt(lamsq(mt,mb,mw))/(16.d0*sw2*ialphw*mt**3)
     &       *(mt**2+mb**2-2.d0*mw**2+((mt-mb)*(mt+mb)/mw)**2)

      if (gamt == 0.d0) then
       gamt=gamtsm0
      end if
ckk>
c      gamt=0.d0
ckk<
c---- partial (t -> b l+ vl)

      rwt=mw/mt
      gwt=gamw/mt

      gamt3=gmu**2*mt**3*mw**2/(96.d0*pi**3)
     &     *((1.d0-3.d0*rwt**4+2.d0*rwt**6+3.d0*rwt**2*gwt**2
     &       -6.d0*rwt**4*gwt**2)*mw/gamw*(pi
     &       -atan(mt**2*gamw/(mw*(mt**2-mw**2-gamw**2))))
     &      +(3.d0*rwt**4-3.d0*rwt**6+rwt**4*gwt**2)
     &  *log(mw**2*(mw**2+gamw**2)/((mt**2-mw**2)**2+mw**2*gamw**2)))


c Complex masses squared:

      mh2=cmplx(mh**2,-mh*gamh,dp)

      if (ischeme == 1) then
        cmh=sqrt(mh2)
      else
        cmh=cmplx(mh,0.d0,dp)
      end if

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(nkin)=1

      aw0=1.d0/dble(nkin)

c Couplings:

      call couplsm(ew,cmw,cmh)

c External particles:

      include 'partcls.dat'

      ralpw0=1.d0

      do i=1,nepl
       if (expl(i) == 'a') then
        ralpw0=ralpw0*ialphw/ialph0
       end if
      end do

      contains
       function f(eps)
       real(dp) :: f,eps
 
        f=3.d0*(1.d0-8.d0*eps**2+20.d0*eps**4)
     &   /sqrt(4.d0*eps**2-1.d0)*acos((3.d0*eps**2-1.d0)/(2.d0*eps**3))
     &   -(1.d0-eps**2)*(23.5d0*eps**2-6.5d0+1.d0/eps**2)
     &   -3.d0*(1.d0-6.d0*eps**2+4.d0*eps**4)*log(eps)

       end function f

      end subroutine parfixkk
